<CsoundSynthesizer>

<CsOptions>
-W
-o Tiger_Rag_done.wav
--logfile=C:\CSound\Waves\Tiger_Rag.log
</CsOptions>

<CsInstruments>
sr = 44100
kr = 4410
ksmps = 10
nchnls = 1
;============================
	;play time stretched file
instr 2
	kamp init 6500
				;45 and 33 1/3 RPM compensation calculations
				;78 RPM / 45 RPM - vinyl recorded speed divided by turntable playback speed
				;78/45 =  2.340 ... ; 1/x= 0.5769
				; Using 33 1/3 LP playback turntable speed here
				;78/33.333 ... =  1.7333 ; 1/x = 0.4273 ...
	ktimewarp =0.4273
				;play at 33 rpm compensation speed
	kresample init 1.7333
				;use Table #1 which contains sound file
	ifn1=1
	ibeg=0
				;suggested small as possible, begin with sr/10
	iwsize=4410
	irandw=882
				;few is good but too few overlaps will cause an audible flutter
				;suggested begin with 15
	ioverlap=30
				;use Table #2 for window function
	ifn2=2
				;to use ktimewarp as "time" pointer set =1
	itimemode=0
	a1 sndwarp kamp, ktimewarp, kresample, ifn1, ibeg, iwsize, irandw, ioverlap, ifn2, itimemode
		out a1
endin	
</CsInstruments>


<CsScore>
				; load file into a table
f1 0 16777216 1 "Tiger_Rag_L.aif" 0 0 0
				; window function  -  half-sine, may try GEN20 window finctions
f 2 0    16384    09  0.5   1    0 ; half-sine
;f 2  0    8192    20   2   456	; Hanning 
;f 2  0    8192    20   3    1	; Bartlett 
;f 2  0    8192    20   4    1	; Blackman 
;f 2  0  16384    20   5    1	; Blackman-Harris 
;f 2  0  16384    20   6    1	; Gaussian 
;f 2  0  16384    20   7    1    2	; Kaiser
;f 2  0    8192   -20   8   .1	; Rectangle 
;f 2  0    4096   -20   9   .75	; Sinc

;play #2 for 0.4273 * 360.5=154.042 sec - stretched time
i2 0 161
</CsScore>
	

</CsoundSynthesizer>
/*
SNDWARP reads sound samples from a table and applies time-stretching and/or pitch 
modification. Time and frequency modification are indepentant from one another. 
For example, a sound can be stretched in time while raising the pitch! 
The window size and overlap arguments are important to the result and should 
be experimented with. In general they should be as small as possible. 
For example, start with iwsize=sr/10 and ioverlap=15. Try irandw=iwsize*.2. 
If you can get away with fewer overlaps, the program will be faster. 
Too few may cause an audible flutter in the amplitude. 
The algorithm reacts differently depending upon the input sound and there 
are no fixed rules for best use in all circumstances. 
With proper tuning, excellent results can be achieved.
*/
/*
Noise removal: removal at original speed (33 1/3)
may be easier than at process compensated speed (78).
*/